<?php
require_once('experiment001.php');

class fetch_tweets extends experiment001 {

	function __construct(){
		parent::__construct();
		$this->tweets = array();
	}
	
	function main(){
		$search_url = 'http://search.twitter.com/search.json?include_entities=true&rpp=6&q=';
		$search_query = urlencode('spotify.com/track -RT @earthpeople');
		$search_result = @json_decode($this->curl($search_url.$search_query));
		if(isset($search_result) && isset($search_result->results)){
			foreach($search_result->results as $results){
				$tweet->from_user = $results->from_user;
				if(isset($results->entities) && isset($results->entities->urls)){
					foreach($results->entities->urls as $url){
						$track->trackid = $this->clean_url($url->expanded_url);
						$track->uri = 'spotify:track:'.$track->trackid;
						$this->add_metadata($track);
						$tweet->tracks[] = $track;
						unset($track);
					}
				}
				$this->tweets[] = $tweet;
				unset($tweet);
			}
			$this->write_file();
		}
		sleep(40);
		$this->main();
	}
	
	function write_file(){
		if($this->tweets){
			foreach($this->tweets as $tweet){
				foreach($tweet->tracks as $track){
					$queue = @file_get_contents($this->qfile);
					$archive = @file_get_contents($this->logfile);
					if(strstr($queue, $track->trackid)){
						echo "skipping track: ".$track->trackid." (already in queue)\n";
						#$this->send_tweet('@'.$tweet->from_user.'! You\'re too late. Someone else already added this track to the play queue.');
					}else if(strstr($archive, $track->trackid)){
						echo "skipping track: ".$track->trackid." (already played once)\n";
						#$this->send_tweet('@'.$tweet->from_user.'! This track has already been played once. Try another one. We like new music.');
					}else{
						$this->talk('added new track to play queue, from '.$tweet->from_user);
						$data = $track->trackid.'|'.$track->artist.'|'.$track->title.'|'.$track->duration.'|'.$tweet->from_user."|00:00:00 0000-00-00|\n";
						$this->send_tweet('@'.$tweet->from_user.'! Thanks! Your track is now queued and will be played in our office shortly.');
						file_put_contents($this->qfile, $data, FILE_APPEND);
						#$this->post_log();
						$track->from_user = $tweet->from_user;
						$this->insert_db($track);
						echo "adding track: ".$track->trackid."\n";
					}
				}
			}
		}
		unset($this->tweets);
	}
	
	function add_metadata($track){
		$search_result = @json_decode($this->curl('http://ws.spotify.com/lookup/1/.json?uri=spotify:track:'.$track->trackid));
		$track->artist = $search_result->track->artists[0]->name;
		$track->title = $search_result->track->name;
		$track->duration = $search_result->track->length;
	}
	
	function clean_url($url = ''){
		if(strstr($url, 'http://open.spotify.com/track/')){
			return $this->clean_trackid($url);
		}else{
			return $this->clean_trackid($this->follow_url($url));
		}
	}

	function clean_trackid($uri = ''){
		preg_match_all('/http:\/\/open.spotify.com\/track\/(.*)/', $uri, $matches);
		return $matches[1][0];
	}
	
	function follow_url($url){
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_HEADER, true);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, false);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
		$a = curl_exec($ch);
		if(preg_match('#Location: (.*)#', $a, $r))
		$l = trim($r[1]);
		if(strstr($l, 'http://open.spotify.com/track/')){
			return $l;
		}else{
			return $this->follow_url($l);
		}
	}

}

new fetch_tweets;